#if 0 /*
#  This is a C/MPW script hybrid!
# Just execute this on the MPW command line, as is - Really!

Unset 1; (Evaluate "{0}"=~/()1./) dev:null
Files "{Libraries}"MacRuntime.o "{Libraries}"IntEnv.o "{Libraries}"Interface.odev:null
  ||(Echo '# MacRuntime, IntEnv.o and Interface.o must exist.'>dev:stderr;Exit 1)

Set objs `Quote "{0}".o`
If "`Exists :obj:str.a.o`"!=""
  Set objs "{objs} :obj:str.a.o -m __MAINTOP"
Else
  Set objs "{objs} `Quote "{Libraries}"MacRuntime.o`"
End

# was far model
#If "`Exists "{0}".o`"==""
  SC "{0}" -o "{0}".o -proto strict -enum int -opt speed -b2 -mc68040 #-load "{CHeaders}"Headers68K
#End
Delete -i "{1}"
#"{Libraries}"ToolLibs.o
ILink -o "{1}" -t 'APPL' -c '????' -pad 0 -state nouse -compact -br 020 {objs} 
 "{Libraries}"IntEnv.o "{Libraries}"Interface.o -sn STDCLIB=Main -sn %A5Init=Main 
 -sn STDIO=Main -sn INTENV=Main -sn SADEV=Main -sn SANELIB=Main -sn SANECLib=Main
Delete -i "{0}".o
Rez -o "{1}" "{0}" -a
Exit 0
#*/
#endif

#if defined(rez) || defined(derez)
data 'ALRT' (128)
{
	$"00340024 00AB01D2 00805555 300A"
};
data 'DITL' (128)
{
	$"00030000 00000056 014E006B 01960404  204F4B20 00000000 000A000E 002A002E"
	$"A0020000 00000000 00090040 004D01A1  88025E30 00000000 0058001C 006800E7"
	$"88074944 203D205E 3100"
};
#else
/*
 activator.c
  for manual [re]activation of the \177XDBTools extension (use is not recommended)

  Created: December 5, 2004 5:26 AM EDST
  Revised: January 2, 2008 2:51 PM EDST

  This was from scratch, and wasnt meant to use the precompiled
    headers... but that eventually got written in.

December 16, 2004 3:12 PM
A.P.: Updated for new format; $50FF8001 shouldve been $68F168F1 [uninit. pointer].
3:18 PM
  Took out the XDBDispatch enum because the trap is not official, and...
    it just looks stupid.  Its worth the trouble replacing every occurence...
*/

/*#include <Folders.h>*/
# include <Resources.h>
/*#include <Patches.h>*/
# include <Dialogs.h>
/*#include <Gestalt.h>*/

# if !TARGET_CPU_68K
#  error Only 68020+ version supplied.
# endif

/* traps */

enum
{ /* trapwords, including two from Traps.h */
	_Gestalt						= 0xA1AD,
	_GetToolTrapAddress				= 0xA746,
	_AliasDispatch					= 0xA823,
	_Unimplemented					= 0xA89F,
	_SetRecRgn						= 0xA8DE,
	_XDBToolsDispatch				= 0xABDB
};

 /* these two selectors are private */
# pragma parameter __A0 XDBInitialize()
  extern Ptr XDBInitialize(void) = {0x70FC, _XDBToolsDispatch};
# pragma parameter __A0 XDBCleanUp()
  extern Ptr XDBCleanUp(void) = {0x70FB, _XDBToolsDispatch};

 /* from Patches.h */
# if TARGET_OS_MAC && TARGET_CPU_68K && !TARGET_RT_MAC_CFM
#  pragma parameter __A0 GetToolTrapAddress(__D0)
# endif
  extern pascal UniversalProcPtr GetToolTrapAddress(UInt16 trapNum) = {_GetToolTrapAddress};

 /* from Gestalt.h */

# if TARGET_OS_MAC && TARGET_CPU_68K && !TARGET_RT_MAC_CFM
#  pragma parameter __D0 Gestalt(__D0, __A1)
# endif
  extern pascal OSErr Gestalt(OSType selector, long *response) = {_Gestalt, 0x2288};

enum
{
	gestaltProcessorType		= FOUR_CHAR_CODE('proc'), /* processor type */
	gestalt68000				= 1,
	gestalt68010				= 2,
	gestalt68020				= 3,
	gestalt68030				= 4,
	gestalt68040				= 5,

	gestaltToolboxTable			= FOUR_CHAR_CODE('tbtt') /*  OS trap table base  */
};

 /* from Folders.h */
  extern pascal OSErr FindFolder(short vRefNum,
    OSType folderType,
    Boolean createFolder,
    short *foundVRefNum,
    long *foundDirID) = {0x7000, _AliasDispatch};

/* typedefs */

typedef void (*InitCaller)(OSType);

/* globals */

QDGlobals		qd;

/*char temporary[514];*/

/*num_print_form standard_unsigned_decimal = {0,'\0',decimal_table};*/
/*num_print_form standard_hexadecimal = {-8,'\0',"\p0123456789ABCDEF"};*/

/* macros */

 /* not originally from LowMem.h */
# define LMROMBase							(0+*(volatile Ptr*)0x02AE)

 /* originally from Debugging.h */
# define MacDebuggerJmp						(0+*(volatile UInt32*)0x0120)
# define MacDebuggerJmpFlag					(0+*(volatile UInt8*)0x0BFF)

# define MacDebuggerCallable()				((UInt32)(1+MacDebuggerJmp)>1 \
	&&(MacDebuggerJmpFlag&(UInt8)0xE0)==(UInt8)0x60)
# define SafeDebugger()						do{if(MacDebuggerCallable()) Debugger();}while(0)

/* code */

static void PStrNumBasePrint(UInt8 *out_str,
	char minus_char,
	short start_digit, /* automatically expanded if non-positive */
	const UInt8 *base_chars, /* pascal string */
	long int _value)
{
	unsigned long int	value;
	unsigned long		x, base, low = (unsigned long)out_str;
	int					start;
	UInt8				*digit = out_str+1;

	out_str[0] = 0, low += 2;
	if ((base=base_chars[0])<=1)
		return; /*base = 8; // octal by default*/
	if (minus_char=='\0' || _value>=0)
		value = _value, --low;
	else
		value = -_value, *digit++ = minus_char;
	if ((start=start_digit)<=0)
	{
		x = value;
		do ++digit; while((x/=base)!=0);
		if (((long)digit-low)<=(start=-start))
			digit = (UInt8*)low+1+start;
	} else
		digit += start;
	out_str[0] = (long)digit-(long)out_str-1;

	while((unsigned long)digit>low)
		x = value, *--digit = base_chars[(x-base*(value/=base))+1];
}

static void report_error(ConstStr255Param str, short err)
{
	Str63			nstr;
	const UInt8		*empty = "\p";

	PStrNumBasePrint(nstr,'-',0,"\p0123456789",err);
	ParamText(str,nstr,empty,empty);
	Alert(128,NULL);
	ParamText(empty,empty,empty,empty);
}

main()
{
	FSSpec			file;/* = {0,0,"\p\x7FXDB Tools"};*/

	UniversalProcPtr	unimp_trap = GetToolTrapAddress(_Unimplemented);
		/* the older one is _SetRectRgn? */
	UniversalProcPtr	setrectrgn = GetToolTrapAddress(_SetRecRgn);

	Handle			h, *xdb_trap;
	long			size, toolbox;
	short			current_refnum = CurResFile(), refnum, err;

	if ((err=Gestalt(gestaltProcessorType,&size))!=noErr
			|| (unsigned)(size-gestalt68020)>gestalt68040-gestalt68020)
		ExitToShell(); /* incompatible/invalid CPU or emulated processor */

	MoreMasters();
	MoreMasters();
	MoreMasters();

# if !TARGET_API_MAC_CARBON
	MaxApplZone();
	InitGraf((Ptr)&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(0);
# endif
	InitCursor();

	*(UInt32*)file.name = '\012\177XD',
		*(UInt32*)(4+file.name) = 'B To',
		*(UInt32*)(8+file.name) = 'ols\0';
	if ((err=Gestalt(gestaltToolboxTable,&toolbox))!=noErr)
		{report_error("\pGestalt returned an error for toolbox table.",err); goto end;}
	/* get the startup disk extensions folder */
	if ((err=FindFolder(-32768L,FOUR_CHAR_CODE('extn'),true,&file.vRefNum,&file.parID))!=noErr)
		{report_error("\pCould not access/generate extensions folder.",err); goto end;}
	SetResLoad(false);
	refnum = FSpOpenResFile(&file,fsRdPerm);
	err = ResError();
	SetResLoad(true);
	if (err<0 || refnum<=0)
		{report_error("\pError attempting to open XDB Tools.",err); goto end;}
	UseResFile(refnum);
	SetResLoad(false);
	h = GetResource('XPTC',0);
	err = ResError();
	SetResLoad(true);
	if (h!=NULL && err>=0)
	{
SafeDebugger();
		if (unimp_trap!=GetToolTrapAddress(_XDBToolsDispatch))
			if ((xdb_trap=(Handle*)XDBCleanUp())!=NULL)
			{
				--xdb_trap;
				if ((setrectrgn=(UniversalProcPtr)*xdb_trap)!=NULL
						&& (Ptr)setrectrgn>LMROMBase)
					*(UniversalProcPtr*)(toolbox+(_SetRecRgn&0x3FF)*4) = setrectrgn;
				DisposePtr((Ptr)xdb_trap);
			}
		if ((size=GetResourceSizeOnDisk(h))>0)
		{
			/* we are in a process application heap; traps must be set manually */
			if ((xdb_trap=(Handle*)NewPtrSys(size+8))==NULL)
			{
				report_error("\pError allocating system pointer.",MemError());
				goto close;
			}
			*xdb_trap++ = (Handle)setrectrgn;
			*xdb_trap++ = (Handle)0x68F168F1;
			ReadPartialResource(h,0,xdb_trap,size);
			if ((err=ResError())!=noErr)
			{
				DisposePtr((Ptr)(xdb_trap-=2));
				report_error("\pError reading XPTC resource.",ResError());
			} else
			{
				*(Handle**)(toolbox+(_XDBToolsDispatch&0x3FF)*4) = xdb_trap;
				if ((xdb_trap=(Handle*)XDBInitialize())!=NULL
						&& (Ptr)setrectrgn>LMROMBase)
					*(Handle**)(toolbox+(_SetRecRgn&0x3FF)*4) = xdb_trap;
			}
		}
		ReleaseResource(h);
	} else
		report_error("\pError attempting to load XPTC resource.",ResError());
close:
	UseResFile(current_refnum);
	CloseResFile(refnum);
end:
	return 0;
}
#endif/*!(defined(rez) || defined(derez))*/
